package com.supervision.ai.service.hub.domain;

import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import java.io.Serializable;
import java.time.LocalDateTime;

import com.baomidou.mybatisplus.extension.handlers.FastjsonTypeHandler;
import lombok.Data;

/**
 * comfyui提示词表
 * @TableName comfyui_prompt
 */
@Data
@TableName(value ="comfyui_prompt",autoResultMap = true)
public class ComfyuiPrompt implements Serializable {
    /**
     * 主键
     */
    @TableId
    private String id;

    /**
     * 提示词名
     */
    private String promptName;

    /**
     * 提示词类型 0:文生图 1：图生图 2：图生视频
     */
    private String promptType;

    /**
     * 提示词
     */
    @TableField(typeHandler = FastjsonTypeHandler.class)
    private JSONObject prompt;

    /**
     * 创建时间
     */
    @TableField(fill = FieldFill.INSERT)
    private LocalDateTime createTime;

    /**
     * 更新时间
     */
    @TableField(fill = FieldFill.INSERT_UPDATE)
    private LocalDateTime updateTime;

    @TableField(exist = false)
    private static final long serialVersionUID = 1L;

}