package com.supervision.ai.service.hub.domain;

import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import java.io.Serializable;
import java.time.LocalDateTime;
import lombok.Data;

/**
 * 
 * @TableName comfyui_prompt_param
 */
@TableName(value ="comfyui_prompt_param")
@Data
public class ComfyuiPromptParam implements Serializable {
    /**
     * 主键
     */
    @TableId
    private String id;

    /**
     * varchar(64)
     */
    private String promptId;

    /**
     * 参数key
     */
    private String paramKey;

    /**
     * 参数类型 0：整数 1：浮点型 2：字符串 3：布尔值
     */
    private Integer paramType;

    /**
     * 是否必填 true：必填 false:非必填
     */
    private Boolean required;

    /**
     * 创建时间
     */
    @TableField(fill = FieldFill.INSERT)
    private LocalDateTime createTime;

    /**
     * 更新时间
     */
    @TableField(fill = FieldFill.INSERT_UPDATE)
    private LocalDateTime updateTime;

    @TableField(exist = false)
    private static final long serialVersionUID = 1L;

}