package com.supervision.ai.service.hub;

import cn.hutool.core.io.FileUtil;
import cn.hutool.json.JSONUtil;
import com.alibaba.fastjson.JSON;
import com.supervision.ai.service.hub.domain.ComfyuiPrompt;
import com.supervision.ai.service.hub.dto.comfyui.ImageUploadDTO;
import com.supervision.ai.service.hub.dto.comfyui.PromptRunDTO;
import com.supervision.ai.service.hub.dto.comfyui.ResourceViewDTO;
import com.supervision.ai.service.hub.service.ComfyUIApiService;
import com.supervision.ai.service.hub.service.ComfyUIPromptService;
import lombok.extern.slf4j.Slf4j;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;

import java.util.Map;

@Slf4j
@SpringBootTest
public class ComfyUIApiServiceTest {

    @Autowired
    private ComfyUIApiService comfyUIApiService;
    @Test
    public void uploadImageTest() {
        byte[] bytes = FileUtil.readBytes("C:\\Users\\Administrator\\Downloads\\Arya.png");
        ImageUploadDTO res = comfyUIApiService.uploadImage(bytes, "图片1");
        log.info(JSONUtil.toJsonStr(res));

    }

    @Test
    public void runPromptTest() {
        String prompt = "{\"prompt\":{\"4\":{\"inputs\":{\"ckpt_name\":\"sd_xl_base_1.0.safetensors\"},\"class_type\":\"CheckpointLoaderSimple\",\"_meta\":{\"title\":\"Load Checkpoint - BASE\"}},\"5\":{\"inputs\":{\"width\":1024,\"height\":1024,\"batch_size\":1},\"class_type\":\"EmptyLatentImage\",\"_meta\":{\"title\":\"空Latent图像\"}},\"6\":{\"inputs\":{\"text\":\"a cat under the snow with blue eyes, covered by snow, cinematic style, medium shot, professional photo, animal\",\"clip\":[\"4\",1]},\"class_type\":\"CLIPTextEncode\",\"_meta\":{\"title\":\"CLIP文本编码\"}},\"7\":{\"inputs\":{\"text\":\"text, watermark\",\"clip\":[\"4\",1]},\"class_type\":\"CLIPTextEncode\",\"_meta\":{\"title\":\"CLIP文本编码\"}},\"10\":{\"inputs\":{\"add_noise\":\"enable\",\"noise_seed\":2025,\"steps\":25,\"cfg\":8,\"sampler_name\":\"euler\",\"scheduler\":\"normal\",\"start_at_step\":0,\"end_at_step\":20,\"return_with_leftover_noise\":\"enable\",\"model\":[\"4\",0],\"positive\":[\"6\",0],\"negative\":[\"7\",0],\"latent_image\":[\"5\",0]},\"class_type\":\"KSamplerAdvanced\",\"_meta\":{\"title\":\"KSampler (Advanced) - BASE\"}},\"11\":{\"inputs\":{\"add_noise\":\"disable\",\"noise_seed\":0,\"steps\":25,\"cfg\":8,\"sampler_name\":\"euler\",\"scheduler\":\"normal\",\"start_at_step\":20,\"end_at_step\":10000,\"return_with_leftover_noise\":\"disable\",\"model\":[\"12\",0],\"positive\":[\"15\",0],\"negative\":[\"16\",0],\"latent_image\":[\"10\",0]},\"class_type\":\"KSamplerAdvanced\",\"_meta\":{\"title\":\"KSampler (Advanced) - REFINER\"}},\"12\":{\"inputs\":{\"ckpt_name\":\"sd_xl_refiner_1.0.safetensors\"},\"class_type\":\"CheckpointLoaderSimple\",\"_meta\":{\"title\":\"Load Checkpoint - REFINER\"}},\"15\":{\"inputs\":{\"text\":\"evening sunset scenery blue sky nature, glass bottle with a galaxy in it\",\"clip\":[\"12\",1]},\"class_type\":\"CLIPTextEncode\",\"_meta\":{\"title\":\"CLIP文本编码\"}},\"16\":{\"inputs\":{\"text\":\"text, watermark\",\"clip\":[\"12\",1]},\"class_type\":\"CLIPTextEncode\",\"_meta\":{\"title\":\"CLIP文本编码\"}},\"17\":{\"inputs\":{\"samples\":[\"11\",0],\"vae\":[\"12\",2]},\"class_type\":\"VAEDecode\",\"_meta\":{\"title\":\"VAE解码\"}},\"19\":{\"inputs\":{\"filename_prefix\":\"ComfyUI\",\"images\":[\"17\",0]},\"class_type\":\"SaveImage\",\"_meta\":{\"title\":\"保存图像\"}}}}";
        PromptRunDTO res = comfyUIApiService.runPrompt(JSON.parseObject(prompt));
        log.info(JSONUtil.toJsonStr(res));
    }

    @Test
    public void queryHistoryTest() {
        Map<String, Object> res = comfyUIApiService.queryHistory("512f2ad2-2c7b-4227-8e52-86be11c3d5b9");
        log.info(JSONUtil.toJsonStr(res));
    }

    @Test
    public void downloadImageTest() {
        ResourceViewDTO resourceViewDTO = comfyUIApiService.downloadView("ComfyUI_00070_.png");
        FileUtil.writeBytes(resourceViewDTO.getContent(), "C:\\Users\\Administrator\\Downloads\\ComfyUI_00070_.png");
    }

    @Autowired
    private ComfyUIPromptService comfyUIPromptService;

    @Test
    public void test() {
        ComfyuiPrompt comfyuiPrompt = comfyUIPromptService.getById("1");
        System.out.println(comfyuiPrompt);
    }
}
